c*******************************************************************
        subroutine tppamp(  k, p, q, pp, pm,
     .                     nk,np,nq,npp,npm , ampl)
c*******************************************************************
c
        implicit real*8    (b-h,m,o-z)
        implicit complex*16 (a)
        implicit integer (i-l,n)
c
        real*8 k(0:3),p(0:3),q(0:3),pp(0:3),pm(0:3)
        real*8 gal(2),lnmir
        real*8  pPk(0:3),ppPpm(0:3),ppPq(0:3), qMk(0:3)
        real*8 pmMk(0:3), kMpp(0:3), qMp(0:3),pmMp(0:3)
c
        complex*16 uq(4),vpp(4),upm(4),up(4),ek(0:3),oes(4)
        complex*16 crt1(0:3),crt2(0:3),amp(8)
c
        common /kine1/ pi,mimin,mimax,mir,lnmir,e0,pol,me,me2
        common /kine2/ s,rts,ek1,ep1,fac,fac2,sw2,gal,del1,del2
c
c  Internal momentum computation
c
        call psumxx( p, k ,  pPk)
        call psumxx(pp,pm , ppPpm)
        call psumxx(pp, q , ppPq)
        call psubxx( q, k ,  qMk)
        call psubxx(pm, k , pmMk)
        call psubxx( k,pp ,  kMpp)
        call psubxx( q, p ,  qMp)
        call psubxx(pm, p , pmMp)
c
c  The final state wave function of the e+e-pair and recoiled electron
c
        call omxxxx(q ,nq , 1 , uq)
        call imxxxx(pp,npp,-1 , vpp)
        call omxxxx(pm,npm, 1 , upm)
c
c  The initial state wave function of the elctron and photon
c
        call imxxxx(p,np, 1 , up)
        call v0linx(nk, ek)
c
c  amplitude for the diagram (1)
c
        call fvixxx(up,gal,ek,pPk,me,0.D0 , oes)
        call j0xxxx(oes,gal,ppPpm,uq , crt1)
        call jtxxxx(vpp,gal,upm , crt2)
        call cdotxx(crt1,crt2 , amp(1))
c
c  amplitude for the diagram (2)
c
        call fvixxx(up,gal,ek,pPk,me,0.D0 , oes)
        call j0xxxx(oes,gal,ppPq,upm , crt1)
        call jtxxxx(vpp,gal,uq , crt2)
        call cdotxx(crt1,crt2 , amp(2))
c
c  amplitude for the diagram (3)
c
        call ovfxxx(uq,gal,ek,qMk,me,0.D0 , oes)
        call j0xxxx(up,gal,ppPpm,oes , crt1)
        call jtxxxx(vpp,gal,upm , crt2)
        call cdotxx(crt1,crt2 , amp(3))
c
c  amplitude for the diagram (4)
c
        call ovfxxx(upm,gal,ek,pmMk,me,0.D0 , oes)
        call j0xxxx(up,gal,ppPq,oes , crt1)
        call jtxxxx(vpp,gal,uq , crt2)
        call cdotxx(crt1,crt2 , amp(4))
c
c  amplitude for the diagram (5)
c
        call fvixxx(vpp,gal,ek,kMpp,me,0.D0 , oes)
        call j0xxxx(oes,gal,qMp,upm , crt1)
        call jtxxxx(up,gal,uq , crt2)
        call cdotxx(crt1,crt2 , amp(5))
c
c  amplitude for the diagram (6)
c
        call fvixxx(vpp,gal,ek,kMpp,me,0.D0 , oes)
        call j0xxxx(oes,gal,pmMp,uq , crt1)
        call jtxxxx(up,gal,upm , crt2)
        call cdotxx(crt1,crt2 , amp(6))
c
c  amplitude for the diagram (7)
c
        call ovfxxx(upm,gal,ek,pmMk,me,0.D0 , oes)
        call j0xxxx(vpp,gal,qMp,oes , crt1)
        call jtxxxx(up,gal,uq , crt2)
        call cdotxx(crt1,crt2 , amp(7))
c
c  amplitude for the diagram (8)
c
        call ovfxxx(uq,gal,ek,qMk,me,0.D0 , oes)
        call j0xxxx(vpp,gal,pmMp,oes , crt1)
        call jtxxxx(up,gal,upm , crt2)
        call cdotxx(crt1,crt2 , amp(8))
c
        ampl= amp(1)-amp(2)+amp(3)-amp(4)
     .       +amp(5)-amp(6)+amp(7)-amp(8)
cc      ampl= amp(5)+amp(7)
c
        return
        end
