c**************************************************************
                       SUBROUTINE USERIN
c**************************************************************
c
        implicit real*8    (a-h,m,o-z)
        implicit integer (i-l,n)
        real*8 gal(2),lnmir,ep(3)
        real*8 k0(0:3),k1(0:3),p0(0:3),p1(0:3)
        parameter(nhist=1,nscat=0)
        integer mloop
c
        common /plotb/ ibuff(281*nhist+2527*nscat+281)
        common /kine1/ pi,mimin,mimax,mir,lnmir,e0,pol,me,me2
        common /kine2/ s,rts,ek1,ep1,fac,fac2,sw2,gal,del1,del2
        common /momnt/ k0,k1,p0,p1
	common /cutof/ qmin,paircut,polmin,polmax,opnmin,opnmax
c
        common /base1/ xl(25),xu(25),ndim,ngdim,ig(25),ncall
        common /base2/ acc1,acc2,itmx1,itmx2
        common /loop0/ loopc,ircode
        common /loop1/ loop,mloop
        common /dump/  ievent,idumpflag,ievmax
c	common /pawc/  h(40000)
	data ep /250. , 400. , 550./
c
	if(loopc.le.0.or.loopc.gt.40)stop
c----------  for mloop=1 -----------
	read(*,*)pol
	read(*,*)qmin
	read(*,*)paircut
	read(*,*)polmin,polmax
	read(*,*)opnmin,opnmax
	read(*,*)e0
c-----------------------------------
c
c---------  for many loop  ---------
c	pol    = 100.
c	qmin   = 0.3
c	paircut= 0.034
c	polmin = 0.424
c	polmax = 0.62
c	opnmin = 0.036
c	opnmax = 0.042
c	e0     = 400
c-----------------------------------
c	e0 = 10.**(loopc/10.)
c	e0 = ep(loopc)
c	opnmin = 0.002*(real(loopc-1))
c	opnmax = 0.002*real(loopc)
c----------------------------------
c
	ievent    = 0
	idumpflag = 1
c	ievmax    = 300
	read(*,*)ievmax
c
        ncall = 10000
        itmx1 = 5
        itmx2 = 6
        acc1  = 0.05
        acc2  = 0.05
c
        me  = 0.511003414
        pi  = dble(3.1415926535897932384626433832795)
        sw2 = 0.23
        me2 = me**2
        s   = 2.*me*e0+me2
        rts = sqrt(s)
        fac = 3.893857D5/(rts*me*e0*1024.*pi**5)
        call coupl2(sw2 , gal)
        ek1 = .5*rts*(1.-me2/s)
        ep1 = .5*rts*(1.+me2/s)
        call momntx(e0 , 0.D0 , 1.D0 , 0.D0 , k0)
        call momntx(ek1, 0.D0 , 1.D0 , 0.D0 , k1)
        call momntx(me ,   me , 0.D0 , 0.D0 , p0)
        call momntx(ep1,   me ,-1.D0 , 0.D0 , p1)
c
        mimin = 2.*me
        mimax = rts-me
        mir   = mimax/mimin
        lnmir = log(mir)
        del1  = me2/s
        del2  = del1**2
        fac2  = 2.D0+del1+del2
c
c	xl(1) = -1.D0
c	xu(1) =  1.D0
        xl(1) = log( del2/(2.+del1) )
        xu(1) = log( (2.+del2)/del1 )
c
        xl(2) = -pi
        xu(2) =  pi
c
c	xl(3) = mimin
c	xu(3) = mimax
        xl(3) =  0.D0
        xu(3) =  1.D0
c
        xl(4) = -1.D0
        xu(4) =  1.D0
c
        xl(5) = -pi
        xu(5) =  pi
c
        xl(6) =  0.D0
        xu(6) =  32.0D0
c
        ndim  =  6
        ngdim =  5
        ig(6) =  0
c
        write(*,10)e0,rts,pol,ievmax
10      format(1X,
     .        /10X'  *******INITIAL CONDITION*******',
     .        /10X'INITIAL PHOTON ENERGY=',G10.3,'MeV',
     .        /10X'CENTER OF MASS ENERGY=',G10.3,'MeV',
     .        /10X'X-POLARIZATION       =',G10.3,'%',
     .        /10X'event number         =',I7,/1X)
c
        call bhinit(nhist,nscat)
	call xhinit( 1,     0.D0,   4.D-2, 50, 'Pair Opening Angle(rad)')
c        call xhinit( 1,    0.D0,   10.D0, 50, 'Recoil Momentum(MeV)')
c        call xhinit( 2,    0.D0,      pi, 50, 'Polar Angle(rad)')
c        call xhinit( 3,      -pi,      pi, 50, 'Azimuthal Angle(rad)')
c        call xhinit( 4,   mimin,   mimax, 50, 'Invariant Mass(MeV)')
c        call xhinit( 5,    0.D0,      e0, 50, 'e+ Energy(MeV)')
c
        return
        end
